//Copyright (C) 2005  Iain Sharp
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//Linking Swell statically or dynamically with other modules is making a
//combined work based on Swell.  Thus, the terms and conditions of the GNU
//General Public License cover the whole combination.
//
//As a special exception, the copyright holders of Swell give you
//permission to integrate Swell and derivative works 
//with multimedia libraries and toolkits similar to
//DirectX and PocketHAL, regardless of the license
//terms of these independent modules, and to copy and distribute the
//resulting combined work under the GPL maintaining this exception.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// For information and contacts for the author go to www.pinedragon.com/swell
//
#include "platformdefs.h"

#ifndef _WIN32_WCE
	// The Window (XWINSIZE,YWINSIZE) and the data arrary (XSIZE,YSIZE) are in opposite orientations
	// which aligns the structure of the data to allow faster writing to screen (yuk)
	// The array is effectively mirrored along a diagonal axis when presented to the user
	#define		XWINSIZE 640
	#define		YWINSIZE 480
	#define		XSIZE 480
	#define		YSIZE 640
#else
	#define		XWINSIZE 240
	#define		YWINSIZE 272
	#define		XSIZE 272
	#define		YSIZE 240
#endif
	
#define		WINSCALE 1
#define		MAXHEAT 0x10000
#define		MINSPEED -2000
#define		MAXSPEED 2000


#define		RULEHEAT	0
#define		RULEWAVE	1
#define		MAXHEATTOOLRADIUS 20

typedef int board_t[XSIZE+2][YSIZE+2];

typedef struct {
   int rule;
	int speed;
   int mask;
} rule_t;

extern board_t board[2];
// extern board_t board2[2];
// extern board_t board3[2];
extern int dbuf;
extern int g_frame;
extern rule_t g_ruleparams;

void AddHeat(int x,int y,int r);
void IterateSlide();
void IterateHeat(rule_t* param,mypixel_t* buffer,int pitch);
void Iterate(rule_t* param,mypixel_t* buffer,int pitch);
void initboard();
void ChangeRule(int newrule);



extern int g_incmaps;
void loadcmaps();
bool iteratecmap();