//Copyright (C) 2005  Iain Sharp
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//Linking Swell statically or dynamically with other modules is making a
//combined work based on Swell.  Thus, the terms and conditions of the GNU
//General Public License cover the whole combination.
//
//As a special exception, the copyright holders of Swell give you
//permission to integrate Swell and derivative works 
//with multimedia libraries and toolkits similar to
//DirectX and PocketHAL, regardless of the license
//terms of these independent modules, and to copy and distribute the
//resulting combined work under the GPL maintaining this exception.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// For information and contacts for the author go to www.pinedragon.com/swell
//
#include <windows.h>


#define NIBS 1
#define MAXICONS 10
#define	FIRSTIBID 3
#ifndef _WIN32_WCE
#define IBORDER 30
#define ICONBORDER 30
#else
#define IBORDER 0
#define ICONBORDER 13
#endif
#define ICONWIDTH 23
#define ICONHEIGHT 23

#define IBHEIGHT 23

#define INICONSTATES 4
#define INORMAL 0
#define IMOUSEDOWN 1
#define ISELECTED 2
#define IDISABLED 3

#define ITYPEHEAT 0
#define ITYPEWAVE 1
#define ITYPEPAUSE 2
#define ITYPEABOUT 3
#define ITYPECOLOUR 4
#define ITYPEENERGY 5
#define ITYPEOFF 6


class CIconBar;

class CIconBar
{
protected:
	HWND	m_hwnd;
	int		m_inicons;
	int		m_astate[MAXICONS];
	int		m_aiconid[MAXICONS];
	int		m_aicontype[MAXICONS];
	HICON	m_aiconhandles[MAXICONS][INICONSTATES];
public:
	CIconBar();
	~CIconBar();
	void AddIconBar(HWND hwnd);
	void AddIcon(int iconnumber, int iconid,int icontype,bool update);
	void SetIconState(int icon,int state,bool update,bool changeparams);
	void Paint(HDC hdc);
	void DoClick(int x, int y);
	void Invalidate();
	int	FindIconFromType(int type);
	HWND GethWnd() { return m_hwnd; }
};


extern CIconBar g_aIconBar[NIBS];
extern int g_inexticonbar;

bool CreateIconBarWindow(HWND inhWnd,int lpos, int tpos, int xsize, int ysize);
bool RegisterIconBarClass();
