//Copyright (C) 2005  Iain Sharp
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//Linking Swell statically or dynamically with other modules is making a
//combined work based on Swell.  Thus, the terms and conditions of the GNU
//General Public License cover the whole combination.
//
//As a special exception, the copyright holders of Swell give you
//permission to integrate Swell and derivative works 
//with multimedia libraries and toolkits similar to
//DirectX and PocketHAL, regardless of the license
//terms of these independent modules, and to copy and distribute the
//resulting combined work under the GPL maintaining this exception.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// For information and contacts for the author go to www.pinedragon.com/swell
//
#define WIN32_LEAN_AND_MEAN

#ifndef _WIN32_WCE
// Requres the following libraries
	#pragma comment ( lib, "ddraw.lib" ) 
	#pragma comment ( lib, "dxguid.lib" )
	#pragma comment ( lib, "winmm.lib" )
#endif

#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <tchar.h>
#include <math.h>
#ifndef _WIN32_WCE
	#include <crtdbg.h>
	#include "dxutil2.h"
	#include "ddutil2.h"
#else
	#include <PocketHAL/PocketHAL.h>
	#include <aygshell.h>
#endif
#include "defs.h"
#include "platformdefs.h"
#include "resource.h"
#include "slider.h"
#include "iconbar.h"




bool g_bActive = false;
bool g_bPaused=false;
#ifndef _WIN32_WCE
	CDisplay *g_pDisplay = NULL;
	CSurface *g_pText = NULL;
#else
	PHAL::Display* g_pDisplay = NULL;
#endif
DWORD g_starttime=0;
POINT g_ptlastmouseloc ={0, 0};
HINSTANCE g_hinst;
HWND g_hwdd;
int g_ixdims[NXDIMS];
int g_iydims[NYDIMS];



//function prototypes
void CleanUp();
void PaintDX(bool biterate);


int CDECL MessageBoxPrintf (TCHAR * szCaption, TCHAR * szFormat, ...)
{
     TCHAR   szBuffer [1024] ;
     va_list pArgList ;

          // The va_start macro (defined in STDARG.H) is usually equivalent to:
          // pArgList = (char *) &szFormat + sizeof (szFormat) ;

     va_start (pArgList, szFormat) ;

          // The last argument to wvsprintf points to the arguments

     _vsntprintf (szBuffer, sizeof (szBuffer) / sizeof (TCHAR), 
                  szFormat, pArgList) ;

          // The va_end macro just zeroes out pArgList for no good reason

     va_end (pArgList) ;

     return MessageBox (NULL, szBuffer, szCaption, MB_OK|MB_ICONERROR) ;
}


void DoAbout()
{
	HDC sourcedc,destdc;
	HBITMAP sourcebit,destbit;
	HGDIOBJ oldsourcebit,olddestbit;
	LPBITMAPINFO lpbi;
	rule_t myrule;
	int i,j;
	mypixel_t buf[YSIZE];
	int* p1;
	int pitch;
	BYTE mask;
	BYTE* pbits;
	BYTE* pbuffer;
	BITMAP mybm;
	sourcedc=CreateCompatibleDC(NULL);
	destdc=CreateCompatibleDC(NULL);
#ifndef _WIN32_WCE
	sourcebit=LoadBitmap(g_hinst,MAKEINTRESOURCE(IDB_ABOUT));
#else
	sourcebit=LoadBitmap(g_hinst,MAKEINTRESOURCE(IDB_POCKETABOUT));
#endif
	GetObject(sourcebit,sizeof(mybm),&mybm);
	pitch=mybm.bmWidthBytes;
	lpbi = (LPBITMAPINFO) new BYTE[sizeof(BITMAPINFOHEADER) + (2 * sizeof(RGBQUAD))];
	lpbi->bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
	lpbi->bmiHeader.biWidth=mybm.bmWidth;
	lpbi->bmiHeader.biHeight=mybm.bmHeight;
	lpbi->bmiHeader.biPlanes=1;
	lpbi->bmiHeader.biBitCount=1;
	lpbi->bmiHeader.biCompression=BI_RGB;
	lpbi->bmiHeader.biSizeImage=2*pitch*mybm.bmHeight;
	lpbi->bmiHeader.biXPelsPerMeter=0;
	lpbi->bmiHeader.biYPelsPerMeter=0;
	lpbi->bmiHeader.biClrUsed=2;
	lpbi->bmiHeader.biClrImportant=0;
	lpbi->bmiColors[0].rgbRed=0;
	lpbi->bmiColors[0].rgbGreen=0;
	lpbi->bmiColors[0].rgbBlue=0;
	lpbi->bmiColors[1].rgbRed=255;
	lpbi->bmiColors[1].rgbGreen=255;
	lpbi->bmiColors[1].rgbBlue=255;
	destbit=CreateDIBSection(NULL,lpbi,DIB_RGB_COLORS,(void **)(&pbuffer),NULL,0);
	oldsourcebit=SelectObject(sourcedc,sourcebit);
	olddestbit=SelectObject(destdc,destbit);
	BitBlt(destdc,0,0,mybm.bmWidth,mybm.bmHeight,sourcedc,0,0,SRCCOPY);

//	oldbits=SelectObject(memdc,membit);
//	for (i=0;i<XSIZE;i++)
//	{
//		p1=&(board[dbuf][i+1][1]);
//		for (j=0;j<YSIZE;j++)
//			if (GetPixel(memdc,j,i)!=0)
//				*p1++=0;
//			else
//				*p1++=0x7fff;
//	}
	for (i=0;i<XSIZE;i++)
	{
		p1=&(board[dbuf][XSIZE-i][1]);
		pbits=pbuffer+pitch*i;
		mask=0x80;
		for (j=0;j<YSIZE;j++)
		{
			*p1++= (*pbits&mask)?0:0x7fff;
			mask >>=1;
			if (mask==0)
			{
				mask=0x80;
				pbits++;
			}
		}
	}
	SelectObject(sourcedc,oldsourcebit);
	DeleteObject(sourcebit);
	DeleteDC(sourcedc);
	SelectObject(destdc,olddestbit);
	DeleteObject(destbit);
	DeleteDC(destdc);
	delete [](BYTE *)lpbi;
	myrule=g_ruleparams;
	myrule.rule=RULEHEAT;
	myrule.speed=0;
#ifndef _WIN32_WCE
	for (i=0;i<20;i++)
#else
	for (i=0;i<5;i++)
#endif
		IterateHeat(&myrule,buf,0);
		g_aIconBar[0].SetIconState(g_aIconBar[0].FindIconFromType(ITYPEPAUSE),IDISABLED,true,false);
	g_bPaused=true;

}

#ifndef _WIN32_WCE
// Desktop
void CalcDims(int x, int y)
{
	if (x>XWINSIZE+2*MINXBORDER+SLIDERWIDTH+DXBORDER)
	{
		g_ixdims[P_DXLEFT]=MINXBORDER+(x-(XWINSIZE+2*MINXBORDER+SLIDERWIDTH+DXBORDER))/2;
		g_ixdims[P_DXRIGHT]=g_ixdims[P_DXLEFT]+XWINSIZE;
		g_ixdims[P_RSLIDERLEFT]=g_ixdims[P_DXRIGHT]+DXBORDER;
		g_ixdims[P_RSLIDERRIGHT]=g_ixdims[P_RSLIDERLEFT]+SLIDERWIDTH;
	}
	else
	{
		g_ixdims[P_DXLEFT]=MINXBORDER;
		g_ixdims[P_DXRIGHT]=g_ixdims[P_DXLEFT]+max(100,x-(2*MINXBORDER+SLIDERWIDTH+DXBORDER));
		g_ixdims[P_RSLIDERLEFT]=g_ixdims[P_DXRIGHT]+DXBORDER;
		g_ixdims[P_RSLIDERRIGHT]=g_ixdims[P_RSLIDERLEFT]+SLIDERWIDTH;
	}
	if (y>YHEIGHT)
	{
		g_iydims[P_DXTOP]=MINYBORDER+(y-YHEIGHT)/2;
		g_iydims[P_DXBOTTOM]=g_iydims[P_DXTOP]+YWINSIZE;
	}
	else
	{
		g_iydims[P_DXTOP]=MINYBORDER;
		g_iydims[P_DXBOTTOM]=g_iydims[P_DXTOP]+max(100,y-(YHEIGHT-YWINSIZE));
	}
	g_iydims[P_BSLIDERTOP]=g_iydims[P_DXBOTTOM]+DXBORDER;
	g_iydims[P_BSLIDERBOTTOM]=g_iydims[P_BSLIDERTOP]+SLIDERWIDTH;
	g_iydims[P_BIBTOP]=g_iydims[P_BSLIDERBOTTOM]+DXBORDER;
	g_iydims[P_BIBBOTTOM]=g_iydims[P_BIBTOP]+IBHEIGHT;
}
#else
// PPC
void CalcDims(int x, int y)
{

	g_ixdims[P_DXLEFT]=0;
	g_ixdims[P_DXRIGHT]=XWINSIZE;
	g_iydims[P_DXTOP]=0;
	g_iydims[P_DXBOTTOM]=YWINSIZE;
	g_iydims[P_BSLIDERTOP]=g_iydims[P_DXBOTTOM]+DXBORDER;
	g_iydims[P_BSLIDERBOTTOM]=g_iydims[P_BSLIDERTOP]+SLIDERWIDTH;
	g_iydims[P_BIBTOP]=g_iydims[P_BSLIDERBOTTOM]+DXBORDER;
	g_iydims[P_BIBBOTTOM]=g_iydims[P_BIBTOP]+IBHEIGHT;
}
#endif

int itemwidth(int litem,int ritem){
	return g_ixdims[ritem]-g_ixdims[litem];
}

int itemheight(int titem,int bitem){
	return g_iydims[bitem]-g_iydims[titem];
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg,
                         WPARAM wParam, LPARAM lParam)
{
  switch(uMsg)
  {
  case WM_CREATE:
	  {

#ifndef _WIN32_WCE
			// Set window size
	RECT rc,rcWork;
	SetRect( &rc, 0, 0, 2*MINXBORDER+XWINSIZE+DXBORDER+SLIDERWIDTH, YHEIGHT );

	AdjustWindowRectEx( &rc, WS_OVERLAPPEDWINDOW, false,NULL );

    SetWindowPos( hWnd, NULL, 0, 0, rc.right-rc.left, rc.bottom-rc.top,
                  SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE );


    //  Make sure our window does not hang outside of the work area
    SystemParametersInfo( SPI_GETWORKAREA, 0, &rcWork, 0 );
    GetWindowRect( hWnd, &rc );
    if( rc.left < rcWork.left ) rc.left = rcWork.left;
    if( rc.top  < rcWork.top )  rc.top  = rcWork.top;
    SetWindowPos( hWnd, NULL, rc.left, rc.top, 0, 0,
                  SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE );

#endif


    break;
	  }
  case WM_CLOSE:
    g_bActive=false;
    CleanUp();
    DestroyWindow(hWnd);
    break;
  case WM_DESTROY:
    PostQuitMessage(0);
    break;
#ifndef _WIN32_WCE
  case WM_MOVE:
	if (g_bActive)
    g_pDisplay->UpdateBounds();
    break;
  case WM_SIZE:
	  if (g_bActive) {
		CalcDims(LOWORD(lParam),HIWORD(lParam));
		MoveWindow(g_hwdd,g_ixdims[P_DXLEFT],g_iydims[P_DXTOP],
						g_ixdims[P_DXRIGHT]-g_ixdims[P_DXLEFT],g_iydims[P_DXBOTTOM]-g_iydims[P_DXTOP],true);
		MoveWindow(g_aSlider[0].GethWnd(),g_ixdims[P_RSLIDERLEFT],g_iydims[P_DXTOP],
						g_ixdims[P_RSLIDERRIGHT]-g_ixdims[P_RSLIDERLEFT],g_iydims[P_DXBOTTOM]-g_iydims[P_DXTOP], true);
		MoveWindow(g_aSlider[1].GethWnd(),g_ixdims[P_DXLEFT],g_iydims[P_BSLIDERTOP],
						g_ixdims[P_DXRIGHT]-g_ixdims[P_DXLEFT],g_iydims[P_BSLIDERBOTTOM]-g_iydims[P_BSLIDERTOP], true);
		MoveWindow(g_aIconBar[0].GethWnd(),g_ixdims[P_DXLEFT],g_iydims[P_BIBTOP],
						g_ixdims[P_DXRIGHT]-g_ixdims[P_DXLEFT],g_iydims[P_BIBBOTTOM]-g_iydims[P_BIBTOP],true);
		g_pDisplay->UpdateBounds();
	  }
	  break;
#else
	case WM_SETFOCUS:
		 SHFullScreen(hWnd,SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON | SHFS_HIDESTARTICON);
#endif

  case WM_PAINT:
	  {
			PAINTSTRUCT ps;
			RECT r;
			GetClientRect(hWnd,&r);
			HDC hdc=BeginPaint(hWnd,&ps);
			SelectObject(hdc,GetStockObject(BLACK_PEN));
			SelectObject(hdc,GetStockObject(BLACK_BRUSH));
			Rectangle(hdc,0,0,r.right,r.bottom);
			EndPaint(hWnd,&ps);
			return 0;
	  }

  default:
    return DefWindowProc(hWnd,uMsg,wParam,lParam);
    break;
  }
  return 0;
}

LRESULT CALLBACK DDrawProc(HWND hWnd, UINT uMsg,
                         WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_CREATE:
#ifndef _WIN32_WCE
			g_pDisplay = new CDisplay();
			if(FAILED(g_pDisplay->CreateChildWindowedDisplay(hWnd,XWINSIZE,YWINSIZE,true)))
				{
					MessageBox(NULL,"Failed to Initialize DirectDraw",
					"DirectDraw Initialization Failure",MB_OK|MB_ICONERROR);
					return -1;
				}
#else
			g_pDisplay=PHAL::Display::Create(hWnd);
			if (g_pDisplay==NULL)
				{
				MessageBox(NULL,_T("Failed to Initialize Pocket HAL"),
				_T("Pocket HAL Initialization Failure"),MB_OK|MB_ICONERROR);
				return -1;
				}
#endif
			return 0;
		case WM_LBUTTONDOWN:
					{
						POINT p;
						p.x= GET_X_LPARAM(lParam); 
						p.y= GET_Y_LPARAM(lParam); 
#ifndef _WIN32_WCE
						g_pDisplay->MapPoint(&p,true);
#endif
						AddHeat(p.y,p.x,10);
						SetCapture(hWnd);
					}
					break;
		case WM_RBUTTONDOWN:
				{
				g_ptlastmouseloc.x=GET_X_LPARAM(lParam);
				g_ptlastmouseloc.y=GET_Y_LPARAM(lParam);
				g_aSlider[0].UpdateFromMouse(0,true);
				g_aSlider[1].UpdateFromMouse(0,true);
				SetCapture(hWnd);
				}
			break;
		case WM_MOUSEMOVE:
			{
				POINT p;
				p.x= GET_X_LPARAM(lParam); 
				p.y= GET_Y_LPARAM(lParam); 
				if (wParam & MK_LBUTTON)
				{
#ifndef _WIN32_WCE
					g_pDisplay->MapPoint(&p,true);
#endif
					AddHeat(p.y,p.x,10);
				}
#ifndef _WIN32_WCE
				if (wParam & MK_RBUTTON)
				{
					g_aSlider[0].UpdateFromMouse(-p.y+g_ptlastmouseloc.y,false);
					g_aSlider[1].UpdateFromMouse(p.x-g_ptlastmouseloc.x,false);
				}
#endif
			}
			break;
#ifndef _WIN32_WCE
		case WM_RBUTTONUP:
#endif
		case WM_LBUTTONUP:
			ReleaseCapture();
			break;
		case WM_PAINT:
			PaintDX(false);
			return 0;


		default:
			return DefWindowProc(hWnd,uMsg,wParam,lParam);
		break;
	}
	 return 0;
}

bool CreateDDWindow(HWND inhWnd,int x,int y,int width, int height)
{

	WNDCLASS wc;

	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hbrBackground=NULL;
	wc.hCursor=LoadCursor(NULL,IDC_CROSS);
	wc.hIcon=NULL;
	wc.hInstance=g_hinst;
	wc.lpfnWndProc=DDrawProc;
	wc.lpszClassName=_T("ddraw");
	wc.lpszMenuName=0;
	wc.style=CS_HREDRAW|CS_VREDRAW;

	if(!RegisterClass(&wc))
	{
		MessageBox(NULL,_T("Couldn't Register Window Class"),
		_T("Window Class Registration Failure"),MB_OK|MB_ICONERROR);
		return false;
	}

	g_hwdd = CreateWindowEx(NULL,_T("ddraw"),_T("ddraw"),
    WS_CHILD ,x,y,width,height,inhWnd,(HMENU)NSLIDERS,
    g_hinst,0);

	if(g_hwdd == NULL)
	{
		MessageBox(NULL,_T("Failed to Create Window"),_T("Window Creation Failure"),
		MB_OK|MB_ICONERROR);
		return false;
	}
    g_bActive=true;
	ShowWindow(g_hwdd,SW_SHOW);
	UpdateWindow(g_hwdd);



  return true;
}

void CleanUp()
{
#ifndef _WIN32_WCE
  SAFE_DELETE(g_pDisplay);
#else
  if (g_pDisplay){
	  delete g_pDisplay;
	  g_pDisplay=NULL;
  }
#endif
}

#ifndef _WIN32_WCE
void HrError(HRESULT hr,char* message)
{
	// MessageBox(NULL, message, "Error!",MB_ICONEXCLAMATION | MB_OK);
	// PostMessage(NULL,WM_CLOSE,0,0);
	DXUtil_Trace(message);
	DXUtil_Trace("\n");
	DXUtil_Trace("\n");
}
#endif


#ifndef _WIN32_WCE
// Desktop only
void BuildBufferFromBoard(LPDIRECTDRAWSURFACE7 pDDs, DDSURFACEDESC2 ddsd)
{
	DWORD xsize, ysize,stride;
	DWORD i,j;
	DWORD* p;
	int* p2;

	xsize=ddsd.dwWidth;
	ysize=ddsd.dwHeight;
	stride=ddsd.lPitch;

	for(j=0;j<ysize;j++)
	{
		p=(DWORD*)((BYTE*)ddsd.lpSurface+stride*j);
		p2=&(board[dbuf][j+1][1]);
//		p2=&(board[dbuf][1][j]);
		for(i=0;i<xsize;i++)
		{
		*(p++)=g_aMyCmap[*p2++>>8];
//			*(p++)=g_aMyCmap[*(p2+=YSIZE+2)>>8];
			
			}
		}
	}
#else
void BuildPPCBufferFromBoard(mypixel_t* buffer,int pitch)
{
	int x,y;
	mypixel_t* pixel;
	int* p;
	for (y=0;y<YWINSIZE;y++)
	{
		pixel=buffer;
		p=&(board[dbuf][y+1][1]);
		for (x=0;x<XWINSIZE;x++)
		{
			*pixel++=(unsigned __int16)g_aMyCmap[(*p++)>>8];
		}
		buffer+=pitch>>1;
	}
}
#endif

#ifndef _WIN32_WCE
// Desktop
void PaintDX(bool biterate)
{
	DDSURFACEDESC2	ddsd;
	HRESULT		hr;
	LPDIRECTDRAWSURFACE7 pDDs;


	// g_pDisplay->Clear(0);
	pDDs=g_pDisplay->GetBackBuffer();

	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	while((hr=pDDs->Lock(NULL,&ddsd,DDLOCK_WAIT,NULL))==DDERR_SURFACELOST)
	{
		DXUtil_Trace("Restoring surface\n");
		hr=pDDs->Restore();
		if (FAILED(hr))
		{
			break;
		}
	} // While
	if (FAILED(hr)) {HrError(hr, "Failed to Lock or Restore Surface"); return;}

	if (biterate)
		Iterate(&g_ruleparams,(mypixel_t*)ddsd.lpSurface,ddsd.lPitch);
	else
		BuildBufferFromBoard(pDDs,ddsd);

	hr=pDDs->Unlock(NULL);
	if (FAILED(hr)) {HrError(hr, "Failed Unlock "); return;}
	


//	TCHAR buffer[200];
//	_stprintf(buffer,"fps =%.1f speed=%4i",1000*double(g_frame)/(1+GetTickCount()-g_starttime),g_ruleparams.speed);

	

//	g_pDisplay->CreateSurfaceFromText(&g_pText,NULL,buffer,
 //   RGB(0,0,0),RGB(0,255,0));
  
	
//	 g_pDisplay->Blt(0,0,g_pText,0);
	g_pDisplay->Present();

//	g_pText->Destroy();
	ValidateRect(g_hwdd,NULL);
}
#else
// PPC
void PaintDX(bool biterate)
{
	unsigned __int16 * buffer;
	PHAL::Surface * mysurface;
	unsigned int pitch;

	if (!g_pDisplay->BeginScene())
		return;
	mysurface=g_pDisplay->GetBackBuffer();
	buffer=mysurface->GetPixels();
	pitch=mysurface->GetPitch();
	if (buffer==NULL) return;
	if (biterate)
		Iterate(&g_ruleparams,buffer,pitch);
	else
		BuildPPCBufferFromBoard(buffer,pitch);

	g_pDisplay->Swap(0);
	ValidateRect(g_hwdd,NULL);
	mysurface->Surface::~Surface();
}
#endif


bool CreateChildWindows(HWND hWnd)
{
	RECT r;
	GetClientRect(hWnd,&r);
	CalcDims(r.right-r.left,r.bottom-r.top);
	if (!CreateDDWindow(hWnd,g_ixdims[P_DXLEFT],g_iydims[P_DXTOP],itemwidth(P_DXLEFT,P_DXRIGHT),itemheight(P_DXTOP,P_DXBOTTOM)))
		return false;

#ifndef _WIN32_WCE
	if (!CreateSliderWindow(hWnd,g_ixdims[P_RSLIDERLEFT],g_iydims[P_DXTOP],itemwidth(P_RSLIDERLEFT,P_RSLIDERRIGHT),itemheight(P_DXTOP,P_DXBOTTOM)))
		return false;
#endif
	if (!CreateSliderWindow(hWnd,g_ixdims[P_DXLEFT],g_iydims[P_BSLIDERTOP],itemwidth(P_DXLEFT,P_DXRIGHT),itemheight(P_BSLIDERTOP,P_BSLIDERBOTTOM)))
		return false;
	if (!CreateIconBarWindow(hWnd,g_ixdims[P_DXLEFT],g_iydims[P_BIBTOP],itemwidth(P_DXLEFT,P_DXRIGHT),itemheight(P_BIBTOP,P_BIBBOTTOM)))
		return false;
	return true;
}


#ifndef _WIN32_WCE
// Desktop
bool checkplatform(){
  OSVERSIONINFO osv;

  osv.dwOSVersionInfoSize=sizeof(osv);
  GetVersionEx(&osv);
  if (osv.dwMajorVersion<5)
  {
	  if ((osv.dwMajorVersion<3)||((osv.dwMinorVersion!=10)&&(osv.dwMinorVersion!=90)))
			MessageBox(NULL,"This program requires Windows 98, Windows ME, Windows 2000, Windows XP or later.",
      "Sorry",MB_OK|MB_ICONERROR);
    return false;
  }
  if (!testdirectxversion(7,0))
  {
    MessageBox(NULL,"This program requires DirectX version 7 or later. Please go to www.microsoft.com/directx",
      "Sorry",MB_OK|MB_ICONERROR);
    return false;
  }
	return true;
}
#else
bool checkplatform(){
	return true;
}
#endif

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPTSTR lpCmdLine, int iShowCmd)
{
  WNDCLASS wc;
  HWND hWnd;
  MSG lpMsg;
  int xsize,ysize;
  LONGLONG cur_time;
  LONGLONG perf_cnt=1;
  LONGLONG next_time=0;
  LONGLONG frame_delay;
  BOOL perf_flag=false;


  g_hinst=hInstance;
  if (!checkplatform())
	  return 0;


  initcmap();
  initboard();
  srand(GetTickCount());
 

  wc.cbClsExtra=0;
  wc.cbWndExtra=0;
  wc.hbrBackground=NULL;
  wc.hCursor=LoadCursor(NULL,IDC_ARROW);
  wc.hIcon=LoadIcon(hInstance,MAKEINTRESOURCE(IDI_SWELL));
  wc.hInstance=hInstance;
  wc.lpfnWndProc=WndProc;
  wc.lpszClassName=_T("wc");
  wc.lpszMenuName=0;
  wc.style=CS_HREDRAW|CS_VREDRAW;

  if(!RegisterClass(&wc))
  {
    MessageBox(NULL,_T("Couldn't Register Window Class"),
      _T("Window Class Registration Failure"),MB_OK|MB_ICONERROR);
    return 0;
  }

  if(!RegisterSliderClass())
  {
    MessageBox(NULL,_T("Couldn't Register Window Class"),
      _T("Window Class Registration Failure"),MB_OK|MB_ICONERROR);
    return 0;
  }
  if(!RegisterIconBarClass())
  {
    MessageBox(NULL,_T("Couldn't Register Window Class"),
      _T("Window Class Registration Failure"),MB_OK|MB_ICONERROR);
    return 0;
  }

#ifndef _WIN32_WCE
  hWnd = CreateWindowEx(0,"wc","Swell",
    WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN ,CW_USEDEFAULT,CW_USEDEFAULT,XWINSIZE-50,YWINSIZE-70,0,0,
    hInstance,0);
#else
 // hWnd=CreateWindow(_T("wc"),_T("Swell"),WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL);
  hWnd=CreateWindow(_T("wc"),_T("Swell"),WS_VISIBLE | WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL);
#endif

  if(hWnd == NULL)
  {
    MessageBox(NULL,_T("Failed to Create Window"),_T("Window Creation Failure"),
      MB_OK|MB_ICONERROR);
    return 0;
  }
  HDC hdc=GetDC(hWnd);
  int cols=GetDeviceCaps(hdc,BITSPIXEL);
  xsize=GetDeviceCaps(hdc,HORZRES);
  ysize=GetDeviceCaps(hdc,VERTRES);
  ReleaseDC(hWnd,hdc);
  if (cols!=SCREENBITS)
  {
	 MessageBoxPrintf(_T("Sorry"),_T("This program requires %2u bit colour."),SCREENBITS);
	 return 0;
  }
  ShowWindow(hWnd,SW_SHOW);
#ifdef _WIN32_WCE
  SHFullScreen(hWnd,SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON | SHFS_HIDESTARTICON);
  MoveWindow(hWnd,0,0,xsize,ysize,FALSE);
#endif

  if (!CreateChildWindows(hWnd))
		return 0;


  g_starttime=GetTickCount();
 // ShowWindow(hWnd,SW_SHOW);
  UpdateWindow(hWnd);

  if (QueryPerformanceFrequency((LARGE_INTEGER *) &perf_cnt))
  {
	  perf_flag=TRUE;
	  frame_delay=perf_cnt/TARGETFPS;
	  QueryPerformanceCounter((LARGE_INTEGER *) &next_time);
	  perf_cnt=perf_cnt/1000;
  }
  else
  {
	  next_time=GetTickCount();
	  frame_delay=1000/TARGETFPS;
  }

  lpMsg.message=NULL;

  while(lpMsg.message != WM_QUIT)
  {
    if(PeekMessage(&lpMsg,0,0,0,PM_REMOVE))
    {
      TranslateMessage(&lpMsg);
      DispatchMessage(&lpMsg);
    }
    else if(g_bActive)
    {
		if (perf_flag)
			QueryPerformanceCounter((LARGE_INTEGER *) &cur_time);
		else
			cur_time=GetTickCount();
		if (cur_time>=next_time)
		{
			g_frame++;
			next_time+=frame_delay;
			PaintDX(!g_bPaused);
			if (iteratecmap())
				{
					int i;
					for (i=0;i<g_inextslider;i++)
						if (g_aSlider[i].GetType()!=SLIDER_CMAP)
							g_aSlider[i].Invalidate();
				}
		}
		else
		{
			if ((next_time-cur_time)>(2*perf_cnt))
				Sleep((DWORD)((next_time-cur_time)/perf_cnt-1));
		}
    }
  }
  return (int)lpMsg.wParam;
}


