//Copyright (C) 2005  Iain Sharp
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//Linking Swell statically or dynamically with other modules is making a
//combined work based on Swell.  Thus, the terms and conditions of the GNU
//General Public License cover the whole combination.
//
//As a special exception, the copyright holders of Swell give you
//permission to integrate Swell and derivative works 
//with multimedia libraries and toolkits similar to
//DirectX and PocketHAL, regardless of the license
//terms of these independent modules, and to copy and distribute the
//resulting combined work under the GPL maintaining this exception.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// For information and contacts for the author go to www.pinedragon.com/swell
//
#ifndef _PLATFORM_H_
#define _PLATFORM_H_

#include <windows.h>
#ifndef _WIN32_WCE
	#include "ddutil2.h"
	#include "dxutil2.h"
#else
	#include <PocketHAL/PocketHAL.h>
#endif

#ifndef _WIN32_WCE
	#define	MINXBORDER 20
	#define MINYBORDER 20
	#define DXBORDER 7
	#define YHEIGHT (YWINSIZE+2*MINYBORDER+SLIDERWIDTH+2*DXBORDER+IBHEIGHT)
	#define SCREENBITS 32
#else
	#define	MINXBORDER 0
	#define MINYBORDER 0
	#define DXBORDER 1
	#define YHEIGHT (YWINSIZE+2*MINYBORDER+SLIDERWIDTH+2*DXBORDER+IBHEIGHT)
	#define SCREENBITS 16
#endif


// For debug code set the target frames per second to 120 so we can see how much
// spare CPU power we have 
#ifdef _DEBUG
#define TARGETFPS 120
#else
#define TARGETFPS 60
#endif


#define NXDIMS 4
#define P_DXLEFT 0
#define P_DXRIGHT 1
#define P_RSLIDERLEFT 2
#define P_RSLIDERRIGHT 3

#define NYDIMS 6
#define P_DXTOP 0
#define P_DXBOTTOM 1
#define	P_BSLIDERTOP 2
#define P_BSLIDERBOTTOM 3
#define P_BIBTOP 4
#define P_BIBBOTTOM 5

#define ABOUTTIME 5000


#ifndef _WIN32_WCE
	typedef DWORD mypixel_t;
#else
	typedef unsigned __int16 mypixel_t;
#endif


#define		MAXCMAPS 100

typedef BYTE cmap_t[256][3];
extern cmap_t g_ithecmaps[MAXCMAPS];

extern mypixel_t g_aMyCmap[256];
extern mypixel_t g_aTargetCmap[256];
extern mypixel_t g_aSliderCmap[256];
extern bool g_bActive;
extern bool g_bPaused;

#ifndef _WIN32_WCE
	extern CDisplay *g_pDisplay;
	extern CSurface *g_pText;
#else
	extern PHAL::Display* g_pDisplay;
#endif

extern DWORD g_starttime;
extern POINT g_ptlastmouseloc;
extern HINSTANCE g_hinst;
extern HWND g_hwdd;
extern int g_ixdims[NXDIMS];
extern int g_iydims[NYDIMS];



void initcmap();
void makemap(int i);
void maketargetmap(int i);
void makeslidermap(int i);
void DoAbout();
bool CreateDDWindow(HWND inhWnd,int x,int y,int width, int height);

#ifndef _WIN32_WCE
	bool testdirectxversion(int minmajor,int minminor);
#endif

#ifndef _WIN32_WCE
#define RG(x) ((BYTE)(((x)&0xff0000)>>16))
#define GG(x) ((BYTE)(((x)&0xff00)>>8))
#define BG(x) ((BYTE) (x)&0xff)
#else
#define RG(x) ((BYTE)(((x)&0xf800)>>8))
#define GG(x) ((BYTE)(((x)&0x7e0)>>3))
#define BG(x) ((BYTE)(((x)&0x1f)<<3))
#endif

#endif