//Copyright (C) 2005  Iain Sharp
//Portions Copyright (C) 1994  Scott Draves <spot@cs.cmu.edu>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//Linking Swell statically or dynamically with other modules is making a
//combined work based on Swell.  Thus, the terms and conditions of the GNU
//General Public License cover the whole combination.
//
//As a special exception, the copyright holders of Swell give you
//permission to integrate Swell and derivative works 
//with multimedia libraries and toolkits similar to
//DirectX and PocketHAL, regardless of the license
//terms of these independent modules, and to copy and distribute the
//resulting combined work under the GPL maintaining this exception.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// For information and contacts for the author go to www.pinedragon.com/swell
//
#include <stdio.h>
#include <tchar.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "defs.h"
#include "platformdefs.h"


#ifndef max
#define max(a,b)            (((a) > (b)) ? (a) : (b))
#endif

#ifndef min
#define min(a,b)            (((a) < (b)) ? (a) : (b))
#endif

board_t board[2];
board_t vel;
// extern board_t board2[2];
// extern board_t board3[2];
int dbuf;
int g_frame=0;
rule_t g_ruleparams={RULEHEAT,0,0xffff};

void AddHeat(int x,int y,int r)
{
	const int heat=800;
	const int pmask=0xffff;
	int i,j;
	int h;
	static int hmap[MAXHEATTOOLRADIUS+1][MAXHEATTOOLRADIUS+1];
	
	for (i=0;i<=r;i++)
		for (j=0;j<=r;j++)
		{
			h=r*r-i*i-j*j;
			if (h>0)
				hmap[i][j]=h;
			else
				hmap[i][j]=0;
		}

	for(i=-r;i<=r;i++)
	{
		for(j=-r;j<=r;j++)
		{
			if((i+x>=1)&&(i+x<=XSIZE)&&(j+y>=1)&&(j+y<=YSIZE))
			{
//				board[dbuf][i+x][j+y]+=(abs(i)+abs(j))*heat;
				board[dbuf][i+x][j+y]+=hmap[abs(i)][abs(j)]*heat;
				if (board[dbuf][i+x][j+y] >= MAXHEAT)
					{ board[dbuf][i+x][j+y]=MAXHEAT-1;}
//				board[dbuf][XSIZE+1-i-x][YSIZE+1-y-j]-=(abs(i)+abs(j))*heat/2;
			}
		}
	}
}


//void IterateLava(rule_t* param)
//{
//	board_t *sboard, *dboard;
//
//	int i,j;
//	double speed;
//	int r;
//	
//
//	sboard = &board[dbuf];
//	dboard = &board[1-dbuf];
//	dbuf = 1-dbuf;
//
//	for(i=1;i<=XSIZE;i++)
//		for(j=1;j<=YSIZE;j++)
//		{
//			speed=double((*sboard)[i][j])/0x10000;
//			r=	speed*(((*sboard)[i-1][j-1])+
//					((*sboard)[i  ][j-1])+
//					((*sboard)[i+1][j-1]))+
//					((*sboard)[i-1][j  ])+
//					((*sboard)[i  ][j  ])+
//					((*sboard)[i+1][j  ])+
//					(1-speed)*(((*sboard)[i-1][j+1])+
//					((*sboard)[i  ][j+1])+
//					((*sboard)[i+1][j+1]));
//			r=r/6;
//			r=r+(j-YSIZE/2)*50/(YSIZE/2);
//			r=max(min(r,0xffff),0);
//			(*dboard)[i][j]=r;
//		}
//
//}


void IterateWave(rule_t* param,mypixel_t* buffer,int pitch)
{
	board_t *sboard, *dboard;

	int i,j;
	int netf;
	int r;
	double frictionfactor=0.02;
	int	i_frictionfactor;
	const double minfrictionfactor=-0.08/2;
	const double maxfrictionfactor=0.17/2;
	int *p, *pbefore,*pafter,*pme,*pvel,*pdest;
	mypixel_t* pixel;

	sboard = &board[dbuf];
	dboard = &board[1-dbuf];
	dbuf = 1-dbuf;

	frictionfactor=(minfrictionfactor+maxfrictionfactor)/2-((maxfrictionfactor-minfrictionfactor)/2)*(double(param->speed)/double(MAXSPEED));
	i_frictionfactor=256-int(0.5+256*frictionfactor);



	for (i=1;i<=XSIZE;i++)
	{
		pbefore=&((*sboard)[i-1][0]);
		p=(*sboard)[i];
		pme=p+1;
		pdest=&((*dboard)[i][1]);
		pafter=&((*sboard)[i+1][0]);
		pvel=&(vel[i][1]);
		pixel=(mypixel_t*) ((BYTE*)buffer+pitch*(i-1));
		for (j=1;j<=YSIZE;j++)
		{
			//netf=	((*sboard)[i-1][j-1])+
			//		((*sboard)[i  ][j-1])+
			//		((*sboard)[i+1][j-1])+
			//		((*sboard)[i-1][j  ])+
			//		((*sboard)[i+1][j  ])+
			//		((*sboard)[i-1][j+1])+
			//		((*sboard)[i  ][j+1])+
			//		((*sboard)[i+1][j+1])-(8*((*sboard)[i  ][j  ]));
			netf=*p++ + *pbefore++ + *pafter++;
			netf+=*pbefore++ + *pafter++;
			p++;
			netf+=*p-- + *pbefore-- + *pafter--;
#define			netfmacro ((netf<<1)-(*pme <<4) -*pme +0x7fff)
//			netf=localgain*netf	-(((*sboard)[i][j])-0x7fff);
//			v=(1-frictionfactor)* (*pvel)+netf*forcefactor;
//			*pvel=(i_frictionfactor * (*pvel)+netf)>>8;
			*pvel=(i_frictionfactor * (*pvel)+netfmacro)>>8;
			r=(*pme++) +*pvel++;
			*pixel++=g_aMyCmap[(*pdest++=min(max(0,r),0xffff)) >> 8];
		}
	}
}


//void IterateSlide()
//{
//	int i,j,r,x;
//	const int speed=-120;
//	const int pmask=0xffff;
//	board_t *sboard, *dboard;
//	int *p, *pbefore,*pafter;
//
//	sboard = &board[dbuf];
//	dboard = &board[1-dbuf];
//	dbuf = 1-dbuf;
//
//	for (i=1;i<=XSIZE;i++)
//	{
//	//	board[1-dbuf][i][YSIZE+1]=(i*(YSIZE+1))%MAXHEAT;
//	}
//
//	for(i=1;i<=XSIZE;i++)
//	{
//		for(j=1;j<=YSIZE;j++)
//		{
//	///*		r=rand();
//	//		if (r<(RAND_MAX/20))
//	//		{
//	//			if (rand() & 1)
//	//			{
//	//				x=board[1-dbuf][i][j+1];
//	//				board[1-dbuf][i][j+1]=board[1-dbuf][i+1][j+1];
//	//				board[1-dbuf][i+1][j+1]=x;
//	//			}
//	//			else
//	//			{
//	//				x=board[1-dbuf][i][j+1];
//	//				board[1-dbuf][i][j+1]=board[1-dbuf][i-1][j+1];
//	//				board[1-dbuf][i-1][j+1]=x;
//	//			}
//	//		}*/
//			board[dbuf][i][j]=((board[1-dbuf][i][j+1] << 1)+board[1-dbuf][i+1][j+1]+board[1-dbuf][i-1][j+1])>>2;
//			}
//		}
//	}

void IterateHeat(rule_t* param,mypixel_t* buffer,int pitch)
{
	int i,j;
	int pmask;
	int speed;
	board_t *sboard, *dboard;
	int *p, *pbefore,*pafter;
	mypixel_t* pixel;

	sboard = &board[dbuf];
	dboard = &board[1-dbuf];
	dbuf = 1-dbuf;

	pmask=param->mask;
	speed=param->speed;


	for(i=1;i<=XSIZE;i++)
	{
		pbefore=&((*sboard)[i-1][1]);
		p=(*sboard)[i];
		pafter=&((*sboard)[i+1][1]);
		pixel=(mypixel_t*)((BYTE*)buffer+pitch*(i-1));
		for(j=1;j<=YSIZE;j++)
		{
			int t;

			t=(*p++);
			t+=((*p++) << 1)+((*pbefore++) << 1)+((*pafter++) << 1);
			t=	(t+(*p--) + speed) >> 3;
//			t = ((((*sboard)[i  ][j-1])+
//				((*sboard)[i-1][j  ]<<1)+
//				((*sboard)[i  ][j  ]<<1)+
//				((*sboard)[i+1][j  ]<<1)
//				((*sboard)[i  ][j+1])

			if (t < 0) {
//				if ((rand()&0x3f)>(g_frame&0x3f))
				if (g_frame%24<22)
					t = 0;
				else
				t = rand()|(rand()<<15);
				}
			t &= pmask;
			(*dboard)[i][j]= t;
			*pixel++=g_aMyCmap[t>>8];
			}
		}
	}

void Iterate (rule_t* param,mypixel_t* buffer,int pitch)
{
	switch (param->rule){
		case RULEHEAT:
			IterateHeat(param,buffer,pitch);
			break;
		case RULEWAVE:
			IterateWave(param,buffer,pitch);
			break;
	}
}


void ChangeRule(int newrule)
{
	g_ruleparams.rule=newrule;
	if (newrule=RULEWAVE)
		memset(vel,0,sizeof(board_t));
}





void initboard()
{
	int i,j;
	memset(board,0,sizeof(board_t)*2);
	for(dbuf=0;dbuf<=1;dbuf++)
	{
		for(j=0;j<=YSIZE+1;j++)
		{
			for(i=0;i<=XSIZE+1;i++)
			{
				if((i==0)||(i==XSIZE+1)||(j==0)||(j==YSIZE+1))
				{
					board[dbuf][i][j]=0;
				}
				else
				{
				 board[dbuf][i][j]=(i*j)%MAXHEAT;
	//			board[dbuf][i][j]=0x7fff;
				// board[dbuf][i][j]=(200*j)%MAXHEAT;
				}
			}
		}
	}
	dbuf=0;
}