//Copyright (C) 2005  Iain Sharp
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//Linking Swell statically or dynamically with other modules is making a
//combined work based on Swell.  Thus, the terms and conditions of the GNU
//General Public License cover the whole combination.
//
//As a special exception, the copyright holders of Swell give you
//permission to integrate Swell and derivative works 
//with multimedia libraries and toolkits similar to
//DirectX and PocketHAL, regardless of the license
//terms of these independent modules, and to copy and distribute the
//resulting combined work under the GPL maintaining this exception.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// For information and contacts for the author go to www.pinedragon.com/swell
//
#include <windows.h>

#define	SLIDER_SPEED 0
#define	SLIDER_CMAP 1
#define NSLIDERS 2

// SLIDERWIDTH and SARRWIDTH should be odd
#define SLIDERWIDTH 23
#define SLXMARGIN 2
#define SLYMARGIN 30
#define SLXBORDER 0
#define SLYBORDER 0
#define SCWIDTH 2
#define SCHEIGHT 5
#define	SARRBORDER 11
#define SARRWIDTH 19
#define SARRHEIGHT 19

#define SFIRSTREPEATTIME 500
#define SREPEATTIME 100

#define SMINMOUSEJOG 50

class CSlider;

class CSlider
{
protected:
	HWND	m_hwnd;
	int		m_iminvalue;
	int		m_imaxvalue;
	int		m_icurrentvalue;
	bool	m_bisvertical;
	int		m_islidertype;
	RECT	m_rmain;
	int		m_imousedown;
	int		m_istoredvalue;

	void	GetSMainRect(RECT* r);
	void	GetSClientRect(RECT* r);
	void	PaintSpeed(HDC hdc);
	void	PaintCmap(HDC hdc);
	int		GetRelCPos();
	int		GetCPos();
	void	PaintArrow(HDC hdc, int dir);
	int		DoClickArrow(int dir);
	void	InternalSetValue(int n,bool isfinal);
public:
	CSlider();
	~CSlider();
	void SetTypeandValue(int type,int value);
	void AddCSlider(HWND hwnd, bool vertical, int type);
	void SetRange(int min, int max);
	void Paint(HDC hdc);
	bool DoClick(int x, int y, bool firstclick);
	void UpdateFromMouse(int dd,bool first);
	void DoUnClick();
	void Invalidate();
	void InvalidateCore();
	int GetValue() {return m_icurrentvalue; }
	int GetType() {return m_islidertype; }
	HWND GethWnd() { return m_hwnd; }
};


extern CSlider g_aSlider[NSLIDERS];
extern int g_inextslider;
extern int g_icurrentcmap;

bool CreateSliderWindow(HWND inhWnd,int lpos, int tpos, int xsize, int ysize);
bool RegisterSliderClass();

void Triangle(HDC hdc, int x1, int y1, int x2, int y2, int x3, int y3);

